﻿Module Module1

    Sub Main()
        'Agregacao()
        'Concatenacao()
        'Conversao()
        'OperacaoElemento()
        'Igualdade()
        'Particionamento
        Projecao()
        Console.ReadLine()

    End Sub
    Public Sub Filtragem()

    End Sub
    Public Sub Projecao()
        Dim nome As String() = {"um", "dois", "cinco"}
        'Encontra o tamanho de todos os elementos
        nome.[Select](Function(f) f.Length)
        ' 3 3 4
        'imprimei elemento com indice
        nome.[Select](Function(a, b) b.ToString() + ":" + a)
        ' 0 : um 1: dois 2:cinco
        'Imprime o item no de vezes pelo seu indice
        nome.SelectMany(Function(a, b) Enumerable.Repeat(a, b)).ToArray()
        'dois 
    End Sub
    Public Sub Particionamento()
        Dim nome As String() = {"Macoratti", ".Net", "Mac", "Visual", "Basic"}

        ' pega dois elementos da lista
        Dim valor1 As List(Of String) = nome.Take(2).ToList()
        ' Macoratti .Net
        'Pula o primeiro elemento na lista
        Dim valor2 As List(Of String) = nome.Skip(1).ToList()
        ' .Net, Mac Visual Basic
        ' Pega elementos com tamanho igual a 3
        Dim valor3 As IEnumerable(Of String) = nome.TakeWhile(Function(f) f.Length = 3)
        'Mac
        ' Pula o elemento quando o tamanho for menor que 4
        Dim valor4 As IEnumerable(Of String) = nome.SkipWhile(Function(f) f.Length < 5)
        ' .Net Mac
    End Sub

    Public Sub Igualdade()
        'Verificando igualdade
        Dim palavras As String() = {"macoratti", "Visual", "Basic"}
        Dim teste As String() = {"MACORATTI", "VISUAL", "BASIC"}

        'Verifica se todos os itens são apresentado em sequencia
        Console.WriteLine(palavras.SequenceEqual({"macoratti", "Visual", "Basic"}))        'True
        ' Caixa Alta é diferente
        Console.WriteLine(palavras.SequenceEqual(teste))                                    'False
        ' Ignorando a caixa alta e baixa na verificação
        Console.WriteLine(palavras.SequenceEqual(teste, StringComparer.OrdinalIgnoreCase))  'True
    End Sub

    Public Sub OperacaoElemento()

        Dim dados As Integer() = {1, 2, 3, 4, 5}

        Console.WriteLine(dados.ElementAt(3))             '4
        Console.WriteLine(dados.ElementAtOrDefault(10))   '0
        Console.WriteLine(dados.First())                   '1

        Dim nome As String() = {"Macoratti", "Mac", "Visual", "Basic"}
        'O nome com 3 letras
        Console.WriteLine(nome.First(Function(m) m.Length = 3))            'Mac
        'Primeiro nome que é maior que 3
        Console.WriteLine(nome.First(Function(m) m.Length > 3))            'Macoratti
        'Ultimo elemento do array
        Console.WriteLine(nome.Last())                                     'Basic
        'tenta obter o item cujo tamanho é 6
        Console.WriteLine(nome.SingleOrDefault(Function(m) m.Length = 6))  'Visual

    End Sub

    Public Sub Conversao()
        Dim dados As Object() = {"1", "2", "3", "4", "5"}
        'Convereter para Ienumerable<string>
        Dim strEnum As IEnumerable(Of String) = dados.Cast(Of String)()
        'Converter para List
        Dim strList As List(Of String) = dados.Cast(Of String)().ToList()
        Console.WriteLine(strList.GetType)
        'Converter para Array
        Dim strArray As String() = dados.Cast(Of String)().ToArray()
    End Sub

    Public Sub Concatenacao()
        'Primeiro array
        Dim dados As Integer() = {1, 2, 3}

        'Concatenando com outro array
        Dim resultado As Integer() = dados.Concat(New Integer() {4, 5, 6}).ToArray()  'resultado 1,2,3,4,5,6
        For Each n In resultado
            Console.Write(n + " ")
        Next
    End Sub

    Private Sub Agregacao()
        'Examplo de agregação

        Dim dados As Integer() = {1, 2, 3, 4, 5, 6, 7, 8}
        'Soma de números
        Console.WriteLine(dados.Sum())
        'resultado => 35
        'Média aritmética de números
        Console.WriteLine(dados.Average())
        'Resultado => 4,5
        'Número Máximo
        Console.WriteLine(dados.Max())
        'Resultado => 8
        Dim strdados As [String]() = {"1", "dois", "tres", "quatro", "cinco"}

        'Item com o comprimento minimo
        Console.WriteLine(strdados.Min())
        'Ans :1
        'Item com o tamanho minimo
        Console.WriteLine(strdados.Min(Function(f) f.Length))
        'Resultado => 1
        'Item com o tamanho maximo
        Console.WriteLine(strdados.Max(Function(f) f.Length))
        'Resultado => 6
    End Sub

End Module
